<?php
/**
* Prestashop Addons | Module by: <App1Pro>
*
* @author    Chuyen Nguyen [App1Pro].
* @copyright Chuyenim@gmail.com
* @license   http://app1pro.com/license.txt
*/

class ProductCommentProNotif extends ObjectModel
{
    public $id_product_comment_pro_notif;
    public $id_product;
    public $id_comment;
    public $id_customer;
    public $type = 0; // 0 => replied, 1 => liked
    public $unread = 1;
    public $date_add;
    
    const TYPE_REPLY = 0;
    const TYPE_REACT = 1;

    public static $definition = array(
        'table' => 'product_comment_pro_notif',
        'primary' => 'id_product_comment_pro_notif',
        'multilang' => false,
        'fields' => array(
            'id_product'   => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId', 'required' => true),
            'id_comment'   => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId', 'required' => true),
            'id_customer'  => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId'),
            'type'         => array('type' => self::TYPE_INT, 'validate' => 'isUnsignedId'),
            'unread'       => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'date_add'     => array('type' => self::TYPE_DATE, 'validate' => 'isDateFormat'),
        ),
    );

    public function countUnreadNotifs($id_customer = 0)
    {
        $sql = 'SELECT COUNT(*)
            FROM `'._DB_PREFIX_.'product_comment_pro_notif` a
            LEFT JOIN `'._DB_PREFIX_.'product_comment_pro_comment` b ON (b.`id_product_comment_pro_comment` = a.`id_comment`)
            WHERE b.`id_customer` = '.(int)$id_customer.' AND a.unread = 1';

        return Db::getInstance()->getValue($sql);
    }

    public function updateStatus($id_customer = 0)
    {
        $sql = 'UPDATE `'._DB_PREFIX_.'product_comment_pro_notif` a
            LEFT JOIN `'._DB_PREFIX_.'product_comment_pro_comment` b ON (b.`id_product_comment_pro_comment` = a.`id_comment`)
            SET a.`unread` = 0
            WHERE b.`id_customer` = '.(int)$id_customer.' AND a.unread = 1';

        return Db::getInstance()->execute($sql);
    }

    public function getNotifs($id_customer = 0, $id_lang = null)
    {
        $sql = 'SELECT a.*,
                COALESCE(d.`nickname`, CONCAT(c.`firstname`, " ", c.`lastname`)) AS `nickname`,
                e.`name` AS `product_name`
            FROM `'._DB_PREFIX_.'product_comment_pro_notif` a
            LEFT JOIN `'._DB_PREFIX_.'product_comment_pro_comment` b ON (b.`id_product_comment_pro_comment` = a.`id_comment`)
            LEFT JOIN `'._DB_PREFIX_.'customer` c ON (c.`id_customer` = a.`id_customer`)
            LEFT JOIN `'._DB_PREFIX_.'product_comment_pro_customer` d ON (d.`id_customer` = a.`id_customer`)
            LEFT JOIN `'._DB_PREFIX_.'product_lang` e ON (e.`id_product` = a.`id_product` AND e.`id_lang` = '.(int)$id_lang.')
            WHERE b.`id_customer` = '.(int)$id_customer;
        $sql .= ' ORDER by a.`date_add` DESC LIMIT 200;';

        return Db::getInstance()->executeS($sql);
    }

    /* Send the notification via email */
    public static function sendNotifMail($email_to, $id_lang, $template = null, $topic_title = null, $var_list = false)
    {
        if (Validate::isEmail($email_to)) {
            Mail::Send(
                (int)$id_lang,
                $template,
                // 'new_response',
                $topic_title,
                $var_list,
                $email_to,
                null,
                null,
                null,
                null,
                null,
                dirname(__FILE__).'/../mails/'
            );
        }
    }
}
