<?php
/**
* Prestashop Addons | Module by: <App1Pro>
*
* @author    Chuyen Nguyen [App1Pro].
* @copyright Chuyenim@gmail.com
* @license   http://app1pro.com/license.txt
*/

class ProductCommentProAjaxModuleFrontController extends ModuleFrontController
{
    public $ssl = true;
    public $errors = array();
    public function initContent()
    {
        parent::initContent();
        $this->table = 'product_comment_pro_comment';
        $this->className = 'ProductCommentProModel';
        $this->ajax = true;
        $this->id_customer = $this->context->customer->id;
    }

    public function displayAjaxGetcomment()
    {
        $current_page = Tools::getValue('page');
        $id_product = Tools::getValue('id_product');
        $record_per_page = (int)Configuration::get('PRODUCTCOMMENTPRO_ROP');
        $id_default_group = $this->context->customer->id_default_group;
        $is_pcpadmin = ($id_default_group == Configuration::get('PRODUCTCOMMENTPRO_ADMIN_GROUP'));
        
        $model = new ProductCommentProModel();
        $no0_comments = $model->countComments($id_product, 0);
        $max_page = ceil($no0_comments / $record_per_page);
        // pd($max_page);
        $pagination = array(
            'offset' => $record_per_page * ($current_page - 1),
            'limit' => $record_per_page,
        );
        $comments = $model->getComments($id_product, 0, $this->id_customer, $pagination);
        
        $this->context->smarty->assign(array(
            'comments'     => $comments,
            'is_pcpadmin'  => $is_pcpadmin,
            'max_page'     => $max_page,
            '_path'        => _MODULE_PCP_URI_,
            'current_page' => $current_page
        ));

        $content_html = $this->context->smarty->fetch(dirname(__FILE__).'/../../views/templates/hooks/comment_list.tpl');
        die(Tools::jsonEncode(array(
            'content_html' => $content_html
        )));
    }
    
    public function displayAjaxGetone()
    {
        $id_comment = Tools::getValue('id_comment');
        $comment = new ProductCommentProModel($id_comment);
        // pd($max_page);
        
        die(Tools::jsonEncode($comment));
    }
    
    public function displayAjaxAccount()
    {
        // Change className to customer class
        $this->className = 'ProductCommentProCustomer';
        
        // Load customer object
        $account = new ProductCommentProCustomer($this->id_customer);
        $account->id_customer = $this->id_customer;
        
        $account->nickname = Tools::getValue('nickname');
        $account->mailing = Tools::getValue('mailing');
        if (!empty($_FILES['avatar']) && $avatar = $this->processImage($_FILES['avatar'], $this->id_customer)) {
            $account->avatar = $avatar;
        }

        $this->checkValidation($_POST);

        if (!empty($this->errors)) {
            die(Tools::jsonEncode(array(
                'error' => implode(', ', $this->errors)
            )));
        }

        if ($account->save()) {
            if (!empty($avatar)) {
                $account->avatar_url = _MODULE_PCP_AVT_URI_.$account->avatar;
            }
            
            die(Tools::jsonEncode($account));
        }
        die();
    }
    
    public function displayAjaxEdit()
    {
        $data = Tools::getValue('data');
        $id_default_group = $this->context->customer->id_default_group;
        $is_pcpadmin = ($id_default_group == Configuration::get('PRODUCTCOMMENTPRO_ADMIN_GROUP'));
        if (!$is_pcpadmin) {
            die(Tools::jsonEncode(array(
                'error' => Tools::displayError('Error permissions')
            )));
        }

        $this->checkValidation($data);
        if (!empty($this->errors)) {
            die(Tools::jsonEncode(array(
                'error' => implode(', ', $this->errors)
            )));
        }
        $model = new ProductCommentProModel($data['id']);
        foreach ($data as $key => $value) {
            $model->$key = $value;
        }

        if ($model->update()) {
            $this->context->smarty->assign(array(
                'comment'      => $model
            ));

            $content_html = $this->context->smarty->fetch(dirname(__FILE__).'/../../views/templates/hooks/comment_content.tpl');
            die(Tools::jsonEncode(array(
                'content_html' => $content_html
            )));
        }
        
        die();
    }
    
    public function displayAjaxSavedata()
    {
        $data = Tools::getValue('data');
        $data['comment'] = trim($data['comment']);
        $this->checkValidation($data);
        if (!empty($this->errors)) {
            die(Tools::jsonEncode(array(
                'error' => implode(', ', $this->errors)
            )));
        }
        
//        if (!$this->id_customer) {
//            die(Tools::jsonEncode(array(
//                'error' => Tools::displayError('Empty customer')
//            )));
//        }
        
        $model = new ProductCommentProModel();
        $model->id_customer = $this->id_customer;
        foreach ($data as $key => $value) {
            $model->$key = $value;
        }

        if (!Configuration::get('PRODUCTCOMMENTPRO_MUST_APPR')) {
            $model->validated();
        }
    
        if ($model->add()) {
            // Send an notification email to comment author.
            if ($model->approved) {
                if ($model->id_parent) {
                    $this->module->prepareNotif(ProductCommentProNotif::TYPE_REPLY, $model->id_parent, nl2br($model->comment), $model->id_customer);
                }
            }
    
            die(Tools::jsonEncode($model));
        }
        die();
    }

    public function displayAjaxVote()
    {
        $data = Tools::getValue('data');
        $this->checkValidation($data);
        if (!empty($this->errors)) {
            die(Tools::jsonEncode(array(
                'error' => implode(', ', $this->errors)
            )));
        }
        $model = new ProductCommentProVote();
        $model->id_customer = $this->id_customer;
        foreach ($data as $key => $value) {
            $model->$key = $value;
        }
        if (!$model->exist()) {
            if ($model->add()) {
                // Send an notification email to comment author.
                $response = ($model->point > 0) ? '+'.$model->point : ''.$model->point;
                $this->module->prepareNotif(ProductCommentProNotif::TYPE_REACT, $model->id_comment, $response, $model->id_customer);
                
                // Output to browser.
                die(Tools::jsonEncode($model));
            }
        } else {
            if ($model->update()) {
                die(Tools::jsonEncode($model));
            }
        }
        
        die();
    }

    public function displayAjaxUnvote()
    {
        $data = Tools::getValue('data');
        $model = new ProductCommentProVote();
        $model->id_customer = $this->id_customer;
        foreach ($data as $key => $value) {
            $model->$key = $value;
        }
        if ($model->unVote()) {
                die(Tools::jsonEncode($model));
        }
        
        die();
    }

    public function displayAjaxReport()
    {
        $data = Tools::getValue('data');
        $this->checkValidation($data);
        if (!empty($this->errors)) {
            die(Tools::jsonEncode(array(
                'error' => implode(', ', $this->errors)
            )));
        }
        $model = new ProductCommentProReport();
        $model->id_customer = $this->id_customer;
        foreach ($data as $key => $value) {
            $model->$key = $value;
        }
        
        if ($model->add()) {
            die(Tools::jsonEncode($model));
        }
        die();
    }

    public function displayAjaxDelete()
    {
        $id_comment = Tools::getValue('id');
        $id_default_group = $this->context->customer->id_default_group;
        $is_pcpadmin = ($id_default_group == Configuration::get('PRODUCTCOMMENTPRO_ADMIN_GROUP'));
        if (!$id_comment || !$is_pcpadmin) {
            die(Tools::jsonEncode(array(
                'error' => 'Error permissions'
            )));
        }
        
        $model = new ProductCommentProModel($id_comment);
        if ($model->delete()) {
            die(Tools::jsonEncode($model));
        }
        die();
    }

    public function checkValidation(array $data)
    {
        $rules = call_user_func(array($this->className, 'getValidationRules'), $this->className);

        // Check required fields
        foreach ($rules['required'] as $field) {
            if (isset($data[$field]) && ($value = $data[$field]) == false && $value != '0') {
                $this->errors[] = sprintf(
                    Tools::displayError('The %s field is required.'),
                    call_user_func(array($this->className, 'displayFieldName'), $field, $this->className)
                );
            }
        }

        // Check fields validity
        foreach ($rules['validate'] as $field => $function) {
            if (isset($data[$field]) && $value = $data[$field]) {
                $res = true;
                if (!Validate::{$function}($value)) {
                    $res = false;
                }

                if (!$res) {
                    $this->errors[] = sprintf(
                        Tools::displayError('The %s field is invalid.'),
                        call_user_func(array($this->className, 'displayFieldName'), $field, $this->className)
                    );
                }
            }
        }
    }

    public function processImage($files, $id, $new_width = 55, $new_height = 55)
    {
        if (isset($files) && isset($files['tmp_name']) && !empty($files['tmp_name'])) {
            if (ImageManager::validateUpload($files, 4096000, array('jpg', 'png'))) {
                $this->errors[] = sprintf(Tools::displayError('Invalid image! We only allow filetype: %s, max-size: 4MB'), 'JPG|PNG');
                return false;
            }

            $path_parts = pathinfo($files['name']);
            //$base = $path_parts['basename'];
            //$name = $path_parts['filename'];
            $ext = $path_parts['extension'];
            // Source information
            $src_info = getimagesize($files['tmp_name']);
            $width = $src_info[0];
            $height = $src_info[1];

            $dst_x = 0;
            $dst_y = 0;
            if ($width >= $height) {
                $dst_x = floor(($width - $height) / 2);
                $width = $height;
            } else {
                $dst_y = floor(($height - $width) / 2);
            }

            $new_tmp = _MODULE_PCP_AVT_DIR_.$id.'-tmp.'.$ext;
            $new_dir = _MODULE_PCP_AVT_DIR_.$id.'.'.$ext;
            if (file_exists($new_tmp)) {
                unlink($new_tmp);
            }

            if (file_exists($new_dir)) {
                unlink($new_dir);
            }

            if (ImageManager::cut(
                $files['tmp_name'],
                $new_tmp,
                $width,
                $width,
                'jpg',
                $dst_x,
                $dst_y
            ) && ImageManager::resize(
                $new_tmp,
                $new_dir,
                (int)$new_width,
                (int)$new_height
            ) && unlink($new_tmp)) {
                return $id.'.'.$ext;
            }
        }

        return false;
    }
}
